#ifndef SAMPLEITEM2_H
#define SAMPLEITEM2_H

#include <plasma/glapplet.h>
#include <plasma/dataengine.h>

#include <QtGui/QWidget>
#include <QtCore/QObject>
#include <QtCore/QTimeLine>
#include <QtSvg/QSvgRenderer>
#include <QGLFramebufferObject>

class QHttp;

class SampleItem2 : public Plasma::GLApplet
{
    Q_OBJECT
public:
    SampleItem2(QObject *parent, const QStringList &args);
    ~SampleItem2();

    virtual QRectF boundingRect() const;
    qreal width() const {
        return boundingRect().width();
    }
    qreal height() const {
        return boundingRect().height();
    }
    virtual void paintGLInterface(QPainter *painter,
                                  const QStyleOptionGraphicsItem *option,
                                  QWidget *widget = 0);

    void saveGLState();
    void restoreGLState();

protected:
    void mousePressEvent(QGraphicsSceneMouseEvent *);
    void mouseDoubleClickEvent(QGraphicsSceneMouseEvent *);
    void mouseMoveEvent(QGraphicsSceneMouseEvent *);
    void hoverMoveEvent(QGraphicsSceneHoverEvent *e);
    void timerEvent(QTimerEvent *);
    void wheelEvent(QGraphicsSceneWheelEvent *);

public slots:
    void animate(qreal);
    void animFinished();
    void draw(QPainter &p);

private:
    QPoint anchor;
    float scale;
    float rot_x, rot_y, rot_z;
    GLuint tile_list;
    GLfloat *wave;

    QImage logo;
    QTimeLine *anim;
    QSvgRenderer *svg_renderer;
    QGLFramebufferObject *fbo;
};

K_EXPORT_PLASMA_APPLET(testgl2, SampleItem2)

#endif
